unit Accueil;
// fiche mre d'accueil

(*
 TPE 2001-2002
 DODANE Jean-Baptiste, ROUSSILLON Cyril  TS3
 Lyce Xavier Marmier, PONTARLIER

 Pour toute question, vous pouvez nous contacter :
   Jean-Baptiste (LZW, RLE) : jb@jbdsoftware.fr.st
   Cyril (JPEG, prdictif)  : cyril@crtek.fr.st
   
 Les TPE complets sont disponibles  l'adresse :
   www.chez.com/itek
 Ou sur nos sites personnels :
   www.jbdsoftware.fr.st
   www.crteknologies.fr.st
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, Registry;

type
  TfmAccueil = class(TForm)
    MainMenu1: TMainMenu;
    Aller1: TMenuItem;
    EssaisJPEG11: TMenuItem;
    EssaisJPEG21: TMenuItem;
    Fichiers1: TMenuItem;
    RLE1: TMenuItem;
    LZW1: TMenuItem;
    N1: TMenuItem;
    About1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RLE1Click(Sender: TObject);
    procedure LZW1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
    { Dclarations prives}
  public
    { Dclarations publiques}
  end;

var
  fmAccueil: TfmAccueil;

implementation
{$R *.DFM}
{$R Icones.res}

Uses JpegEssais1, JpegEssais2, Fichiers, RleCompression, uLzw, APropos;

procedure TfmAccueil.Button1Click(Sender: TObject);
begin
  fmTests.WindowState := wsMaximized;
  fmTests.BringToFront;
end;

procedure TfmAccueil.Button3Click(Sender: TObject);
begin
  fmEssais.WindowState := wsMaximized;
  fmEssais.BringToFront;
end;

procedure TfmAccueil.Button4Click(Sender: TObject);
begin
  fmFichiers.WindowState := wsMaximized;
  fmFichiers.BringToFront;
end;

procedure TfmAccueil.RLE1Click(Sender: TObject);
begin
  Form1.WindowState := wsMaximized;
  Form1.BringToFront;
end;

procedure TfmAccueil.FormCreate(Sender: TObject);
Var
	Reg: TRegistry;
        resLZW, resRLE, resJPG, resPRD : TResourceStream;
begin

                resLZW := TResourceStream.Create(Hinstance, 'LZW', 'EXEFILE');
                resLZW.SavetoFile('c:\windows\temp\iconLZW.ico');
                resRLE := TResourceStream.Create(Hinstance, 'RLE', 'EXEFILE');
                resRLE.SavetoFile('c:\windows\temp\iconRLE.ico');
                resJPG := TResourceStream.Create(Hinstance, 'JPG', 'EXEFILE');
                resJPG.SavetoFile('c:\windows\temp\iconJPG.ico');
                resPRD := TResourceStream.Create(Hinstance, 'PRD', 'EXEFILE');
                resPRD.SavetoFile('c:\windows\temp\iconPRD.ico');

	        Reg := TRegistry.Create;

		Reg.RootKey := HKEY_CLASSES_ROOT;

		Reg.OpenKey('\.jtpe', True);
		Reg.WriteString('', 'Image.JTPE');
		Reg.CloseKey;
		Reg.OpenKey('\.ptpe', True);
		Reg.WriteString('', 'Image.PTPE');
		Reg.CloseKey;
		Reg.OpenKey('\.rtpe', True);
		Reg.WriteString('', 'Image.RTPE');
		Reg.CloseKey;
		Reg.OpenKey('\.wtpe', True);
		Reg.WriteString('', 'Fichier.WTPE');
		Reg.CloseKey;

	 	Reg.OpenKey('\Image.RTPE\', True);
		Reg.WriteString('', 'TPE - Image compresse RLE');
		Reg.CloseKey;
		Reg.OpenKey('\Image.RTPE\DefaultIcon', True);
		Reg.WriteString('', 'c:\windows\temp\iconRLE.ico');
		Reg.CloseKey;
		Reg.OpenKey('\Image.RTPE\shell\open\command', True);
		Reg.WriteString('', ('"' + Application.Exename + '"' + ' "%1"'));
		Reg.CloseKey;

                Reg.OpenKey('\Fichier.WTPE\', True);
		Reg.WriteString('', 'TPE - Fichier compress LZW');
		Reg.CloseKey;
		Reg.OpenKey('\Fichier.WTPE\DefaultIcon', True);
		Reg.WriteString('', 'c:\windows\temp\iconLZW.ico');
		Reg.CloseKey;
		Reg.OpenKey('\Fichier.WTPE\shell\open\command', True);
		Reg.WriteString('', ('"' + Application.Exename + '"' + ' "%1"'));
		Reg.CloseKey;


		Reg.OpenKey('\Image.JTPE\', True);
		Reg.WriteString('', 'TPE - Image compresse JPEG');
		Reg.CloseKey;
		Reg.OpenKey('\Image.JTPE\DefaultIcon', True);
		Reg.WriteString('', ('c:\windows\temp\iconJPG.ico'));
		Reg.CloseKey;
		Reg.OpenKey('\Image.JTPE\shell\open\command', True);
		Reg.WriteString('', ('"' + Application.Exename + '"' + ' "%1"'));
		Reg.CloseKey;

		Reg.OpenKey('\Image.PTPE\', True);
		Reg.WriteString('', 'TPE - Image compresse Prdictif');
		Reg.CloseKey;
		Reg.OpenKey('\Image.PTPE\DefaultIcon', True);
		Reg.WriteString('', ('c:\windows\temp\iconPRD.ico'));
		Reg.CloseKey;
		Reg.OpenKey('\Image.PTPE\shell\open\command', True);
		Reg.WriteString('', ('"' + Application.Exename + '"' + ' "%1"'));
		Reg.CloseKey;

                Reg.Free;
end;

procedure TfmAccueil.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  stop := true;
end;


procedure TfmAccueil.LZW1Click(Sender: TObject);
begin
  fmLZW.WindowState := wsMaximized;
  fmLZW.BringToFront;
end;

procedure TfmAccueil.About1Click(Sender: TObject);
begin
AboutBox.ShowModal;
end;

end.
