unit Fichiers;
// utilisation directe des diffrents formats

(*
 TPE 2001-2002
 DODANE Jean-Baptiste, ROUSSILLON Cyril  TS3
 Lyce Xavier Marmier, PONTARLIER

 Pour toute question, vous pouvez nous contacter :
   Jean-Baptiste (LZW, RLE) : jb@jbdsoftware.fr.st
   Cyril (JPEG, prdictif)  : cyril@crtek.fr.st
   
 Les TPE complets sont disponibles  l'adresse :
   www.chez.com/itek
 Ou sur nos sites personnels :
   www.jbdsoftware.fr.st
   www.crteknologies.fr.st
*)

interface

Uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, _JTPE, _PTPE, _Bibliotheque, JpegOptions, Informations,
  Menus, Progression, RleDecompression, uLZW;

type
    TfmFichiers = class(TForm)
    dlgOpen: TOpenDialog;
    dlgSave: TSaveDialog;
    MainMenu1: TMainMenu;
    miFichier: TMenuItem;
    miOuvrir: TMenuItem;
    miEnreg: TMenuItem;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    ImageAff: TImage;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    N1: TMenuItem;
    Informations1: TMenuItem;
    procedure btnOuvrirClick(Sender: TObject);
    procedure btnEnregClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Informations1Click(Sender: TObject);
  private
    { Dclarations prives}
  public
    { Dclarations publiques}
  end;

Procedure Pss(Progression: Integer);

Var
  fmFichiers: TfmFichiers;

Implementation

uses Accueil, RleCompression, RleProgression;

{$R *.DFM}

Var
	Img: sImage;
  Fichier: sFichier;
//  Fichier: pFichier = @Fichier2;

//Pss: TProgressEvent;

Procedure Pss(Progression: Integer);
Begin
	fmProgress.ProgressBar.Position := Progression;
  Application.ProcessMessages;
End;

procedure TfmFichiers.btnOuvrirClick(Sender: TObject);
begin
	If dlgOpen.Execute Then
	Begin
        If UpperCase(ExtractFileExt(dlgOpen.FileName)) = '.RTPE' Then
           Begin
           Form1.WindowState := wsMaximized;
           Form1.BringToFront;
           Form4.ODialog.FileName := dlgOpen.FileName;
           Form4.Show;
           Form1.Refresh;
           Form4.Refresh;
           Form4.LoadInformations(True);
           Exit;
           End;

        If UpperCase(ExtractFileExt(dlgOpen.Filename)) = '.WTPE' Then
           Begin
           FmLZW.WindowState := wsMaximized;
           FmLZW.BringToFront;
           FmLZW.Edit1.Text := DlgOpen.FileName;
           Exit;
           End;


  	If ImageAff <> nil Then ImageAff.Free; fmProgress.Show; fmAccueil.Enabled := False;
  	If UpperCase(ExtractFileExt(dlgOpen.FileName)) = '.BMP' Then ChargerAllBMP(dlgOpen.FileName, Img, Pss, @Fichier) Else
		If UpperCase(ExtractFileExt(dlgOpen.FileName)) = '.JTPE' Then	ChargerJTPE(dlgOpen.FileName, Img, Pss, @Fichier) Else
		If UpperCase(ExtractFileExt(dlgOpen.FileName)) = '.PTPE' Then ChargerPTPE(dlgOpen.FileName, Img, Pss, @Fichier) Else


    fmFichiers.Caption := ExtractFileName(dlgOpen.FileName);
    ImageAff := TImage.Create(fmFichiers);
    ImageAff.Left := 3; ImageAff.Top := 3;
    ImageAff.Width := Img.Largeur; ImageAff.Height := Img.Hauteur;
    Afficher(Img, ImageAff.Canvas, Pss);
    ImageAff.Parent := fmFichiers;
		FormResize(Sender);
    fmProgress.Close; fmAccueil.Enabled := True;
  	miEnreg.Enabled := True;
    Beep();
    AfficherInfos(Img, @Fichier);
	End;
end;

procedure TfmFichiers.btnEnregClick(Sender: TObject);
Var
	Qualite: Integer;
begin
	dlgSave.FileName := ExtractFileName(dlgOpen.FileName);
  dlgSave.FileName := Copy(dlgSave.FileName, 1, Length(dlgSave.FileName) - Length(ExtractFileExt(dlgSave.FileName)));
	If dlgSave.Execute Then
  Begin
    Case dlgSave.FilterIndex Of
    	1: Begin
      	If UpperCase(ExtractFileExt(dlgSave.FileName)) <> '.BMP' Then dlgSave.FileName := dlgSave.FileName + '.bmp';
        fmProgress.Show; fmAccueil.Enabled := False; SauverBMP(dlgSave.FileName, Img, Pss) End;
      2: Begin
      	If UpperCase(ExtractFileExt(dlgSave.FileName)) <> '.JTPE' Then dlgSave.FileName := dlgSave.FileName + '.jtpe';
        If fmJpegOptions.ShowModal = mrOk Then Begin fmProgress.Show; fmAccueil.Enabled := False;
					If fmJpegOptions.rgQualite.ItemIndex = 1 Then Qualite := 0 Else Qualite := StrToInt(fmJpegOptions.edQualite.Text);
	        SauverJTPE(dlgSave.FileName, Img, Qualite, Pss) End; End;
      3: Begin
      	If UpperCase(ExtractFileExt(dlgSave.FileName)) <> '.PTPE' Then dlgSave.FileName := dlgSave.FileName + '.ptpe';
				fmProgress.Show; fmAccueil.Enabled := False; SauverPTPE(dlgSave.FileName, Img, Pss) End;
      4: Begin
           If UpperCase(ExtractFileExt(dlgSave.FileName)) <> '.RTPE' then dlgSave.FileName := dlgSave.FileName + '.rtpe';
           Form1.WindowState := wsMaximized;
           Form1.BringToFront;
           Form1.OPDialog.FileName := dlgOpen.FileName;
           Form1.OPDialog.Tag := 777;
           Form2.SDialog.Filename := dlgSave.Filename;
           Form1.BtnLoad.Click;
           Exit;
           End;
      5: Begin
           If UpperCase(ExtractFileExt(dlgSave.FileName)) <> '.WTPE' then dlgSave.FileName := dlgSave.FileName + '.wtpe';
           FmLZW.WindowState := wsMaximized;
           FmLZW.BringToFront;
           fmLZW.Edit1.Text := dlgOpen.FileName;
           fmLZW.Edit3.Text := dlgSave.Filename;
           fmLZW.Refresh;
           ShowMessage('Vous pouvez  prsent COMPRESSER ou changer des options');
           Exit;
           End;


    End;
    fmProgress.Close; fmAccueil.Enabled := True;
    Beep();
  End;
end;





//---------------------------------------------------------------

procedure TfmFichiers.FormCreate(Sender: TObject);
begin
  If ParamStr(1) <> '' Then
  Begin
   	miEnreg.Enabled := True;
  	If UpperCase(ExtractFileExt(ParamStr(1))) = '.BMP' Then ChargerAllBMP(ParamStr(1), Img, Pss, @Fichier) Else
		If UpperCase(ExtractFileExt(ParamStr(1))) = '.JTPE' Then ChargerJTPE(ParamStr(1), Img, Pss, @Fichier);
		If UpperCase(ExtractFileExt(ParamStr(1))) = '.PTPE' Then ChargerPTPE(ParamStr(1), Img, Pss, @Fichier);
    fmFichiers.Caption := ParamStr(1);
    Beep();
    AfficherInfos(Img, @Fichier);
	End;

end;

procedure TfmFichiers.ScrollBar1Change(Sender: TObject);
begin
	ImageAff.Left := -ScrollBar1.Position + 3;
end;

procedure TfmFichiers.ScrollBar2Change(Sender: TObject);
begin
	ImageAff.Top := -ScrollBar2.Position + 3;
end;

procedure TfmFichiers.FormResize(Sender: TObject);
Var X: Integer;
begin
  X := ImageAff.Width - ClientWidth + 6;
  If X <= 0 Then
  Begin
  	ScrollBar1.Hide; ImageAff.Left := 3;
	  X := ImageAff.Height - ClientHeight + 6;
  End Else
  Begin
  	ScrollBar1.Show;
    ScrollBar1.Max := X;
	  X := ImageAff.Height - ClientHeight + 19;
  End;
  If X <= 0 Then
  Begin
    ScrollBar2.Hide;
    ImageAff.Top := 3;
  End Else
  Begin
  	ScrollBar2.Show;
    ScrollBar2.Max := X;
	  X := ImageAff.Width - ClientWidth + 19;
	  If X >= 0 Then Begin ScrollBar1.Show; ScrollBar1.Max := X End;
  End;
  Shape1.BringToFront; Shape2.BringToFront;
  Shape3.BringToFront; Shape4.BringToFront;
End;

procedure TfmFichiers.FormActivate(Sender: TObject);
begin
//	If fmProgress.Visible Then Begin Beep; fmProgress.Show End;
end;

procedure TfmFichiers.Informations1Click(Sender: TObject);
begin
If (Img.Pix <> Nil) and (@Fichier <> Nil) then AfficherInfos(Img, @Fichier) Else ErrorMessage('Il n''y a aucune information  afficher');
end;

end.
