unit Informations;
// affiche les infos sur une image ouverte

(*
 TPE 2001-2002
 DODANE Jean-Baptiste, ROUSSILLON Cyril  TS3
 Lyce Xavier Marmier, PONTARLIER

 Pour toute question, vous pouvez nous contacter :
   Jean-Baptiste (LZW, RLE) : jb@jbdsoftware.fr.st
   Cyril (JPEG, prdictif)  : cyril@crtek.fr.st
   
 Les TPE complets sont disponibles  l'adresse :
   www.chez.com/itek
 Ou sur nos sites personnels :
   www.jbdsoftware.fr.st
   www.crteknologies.fr.st
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, _Bibliotheque;

type
  TfmInfos = class(TForm)
    SG: TStringGrid;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives}
  public
    { Dclarations publiques}
  end;

  Procedure AfficherInfos(Img: sImage; Fichier: pFichier);

var
  fmInfos: TfmInfos;

implementation

{$R *.DFM}

procedure TfmInfos.Button1Click(Sender: TObject);
begin
 	SG.RowCount := 6;
	ModalResult := mrOk;
end;

procedure TfmInfos.FormCreate(Sender: TObject);
begin
  SG.ColWidths[1] := 254;
  SG.Cells[0,0] := '  Nom';
  SG.Cells[0,1] := '  Format';
  SG.Cells[0,2] := '  Largeur (pix)';
  SG.Cells[0,3] := '  Hauteur (pix)';
  SG.Cells[0,4] := '  Taille (octets)';
  SG.Cells[0,5] := '  Couleurs';
end;

Procedure AfficherInfos(Img: sImage; Fichier: pFichier);
Var i: Integer;
Begin
  With fmInfos Do
  Begin
  	SG.Cells[1,0] := ' ' + Fichier.Nom;
	  SG.Cells[1,1] := ' ' + Fichier.Format;
	  SG.Cells[1,2] := ' ' + IntToStr(Img.Largeur);
  	SG.Cells[1,3] := ' ' + IntToStr(Img.Hauteur);
	  SG.Cells[1,4] := ' ' + IntToStr(Fichier.Taille);
	  SG.Cells[1,5] := ' ' + IntToStr(Img.nbCouleurs);
		For i := 0 To 1 Do If Fichier.AutreT[i] <> '' Then
    Begin
    	SG.RowCount := 7 + i;
    	SG.Cells[0,6+i] := ' ' + Fichier.AutreT[i];
    	SG.Cells[1,6+i] := ' ' + Fichier.AutreC[i];
      Fichier.AutreT[i] := '';
    End;
  End;
  fmInfos.ShowModal();
End;

end.
