unit JpegEssais1;
// etude du JPEG, 1

(*
 TPE 2001-2002
 DODANE Jean-Baptiste, ROUSSILLON Cyril  TS3
 Lyce Xavier Marmier, PONTARLIER

 Pour toute question, vous pouvez nous contacter :
   Jean-Baptiste (LZW, RLE) : jb@jbdsoftware.fr.st
   Cyril (JPEG, prdictif)  : cyril@crtek.fr.st
   
 Les TPE complets sont disponibles  l'adresse :
   www.chez.com/itek
 Ou sur nos sites personnels :
   www.jbdsoftware.fr.st
   www.crteknologies.fr.st
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, _Bibliotheque, _JTPE, ExtCtrls, Fichiers, _PTPE;

type
  TfmTests = class(TForm)
    GroupBox1: TGroupBox;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    btnTransfoLC: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit9: TEdit;
    btnChargerLC: TButton;
    ColorDialog1: TColorDialog;
    GroupBox2: TGroupBox;
    btnDCT: TButton;
    btnIDCT: TButton;
    btnOuvrir: TButton;
    btnSuivant: TButton;
    btnArreter: TButton;
    Edit10: TEdit;
    btnQuant: TButton;
    dlgOpen: TOpenDialog;
    StringGrid1: TStringGrid;
    StringGrid2: TStringGrid;
    StringGrid3: TStringGrid;
    StringGrid4: TStringGrid;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    btnQuAuto: TButton;
    btnDequant: TButton;
    Label4: TLabel;
    StringGrid5: TStringGrid;
    StringGrid6: TStringGrid;
    Image1: TImage;
    Image2: TImage;
    Bevel1: TBevel;
    Panel1: TPanel;
    Button1: TButton;
    dlgOpen2: TOpenDialog;
    procedure btnDCTClick(Sender: TObject);
    procedure btnIDCTClick(Sender: TObject);
    procedure btnTransfoLCClick(Sender: TObject);
    procedure btnChargerLCClick(Sender: TObject);
    procedure btnSuivantClick(Sender: TObject);
    procedure btnArreterClick(Sender: TObject);
    procedure btnOuvrirClick(Sender: TObject);
    procedure btnQuantClick(Sender: TObject);
    procedure btnQuAutoClick(Sender: TObject);
    procedure btnDequantClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives}
  public
    { Dclarations publiques}
  end;

var
  fmTests: TfmTests;
  stop: Boolean = false;

implementation

uses Progression, Accueil;
{$R *.DFM}

Var
	Img, Img2: sImage;
  Cont: Boolean = False;

procedure TfmTests.btnDCTClick(Sender: TObject);
Var
	i, j: Integer;
	t1, t2: Tab8x8;
begin
	For i := 0 To 7 Do For j := 0 To 7 Do
  	t1[i, j] := StrToInt(StringGrid1.Cells[i, j]);
  DCT(t1, t2);
	For i := 0 To 7 Do For j := 0 To 7 Do
  	StringGrid2.Cells[i, j] := IntToStr(t2[i, j]);
end;

procedure TfmTests.btnIDCTClick(Sender: TObject);
Var
	i, j: Integer;
	t1, t2: Tab8x8;
begin
	For i := 0 To 7 Do For j := 0 To 7 Do
  	t1[i, j] := StrToInt(StringGrid5.Cells[i, j]);
  IDCT(t1, t2);
	For i := 0 To 7 Do For j := 0 To 7 Do
  Begin
  	If t2[i, j] < 0 Then t2[i, j] := 0 else If t2[i, j] > 255 Then t2[i, j] := 255;
  	StringGrid6.Cells[i, j] := IntToStr(t2[i, j]);
    fmTests.Image2.Canvas.Pixels[i, j] := RGB(t2[i, j], t2[i, j], t2[i, j]);
  End;
  fmTests.Image1.Canvas.CopyRect(Rect(100,0,180,80), fmTests.Image2.Canvas, Rect(0,0,8,8));
end;

//---------------------------------------------------------------------------------------------
Procedure EcrireBloc(Var Img: sImage; R: TRect);
Var
	i, j: Integer;
  Ta1: Tab8x8;
  Pixel: TColor;
Begin
 	For j := 0 To 7 Do For i := 0 To 7 Do
  Begin
		Pixel := Img.Pix[R.Left + i, R.Top + j];
    Ta1[i, j] := Round(0.299 * GetRValue(Pixel) + 0.587 * GetGValue(Pixel) + 0.114 * GetBValue(Pixel));
    fmTests.Image2.Canvas.Pixels[i, j] := RGB(Ta1[i, j], Ta1[i, j], Ta1[i, j]);
    fmTests.StringGrid1.Cells[i, j] := IntToStr(Ta1[i, j]);
  End;
  fmTests.Image1.Canvas.CopyRect(Rect(0,0,80,80), fmTests.Image2.Canvas, Rect(0,0,8,8));
End;

//---------------------------------------------------------------------------------------------
Procedure LirePasAPas(Var Img: sImage; Qualite: Byte);
Var
	m, n: Integer;
begin
	For n := 0 To Img.Hauteur Div 8 - 1 Do
  BEGIN
  	For m := 0 To Img.Largeur Div 8 - 1 Do
	  BegiN
    	EcrireBloc(Img, Rect(m * 8, n * 8, m * 8 + 7, n * 8 + 7));
      Cont := False;
      While Not(Cont) Do Begin Application.ProcessMessages; If stop then Exit End;
    EnD
  END;
End;

procedure TfmTests.btnSuivantClick(Sender: TObject);
begin
Cont := true;
end;

procedure TfmTests.btnArreterClick(Sender: TObject);
begin
  stop := true;
end;

procedure TfmTests.btnOuvrirClick(Sender: TObject);
begin
	If dlgOpen.Execute Then
	Begin
  	ChargerAllBMP(dlgOpen.FileName, Img, nil, nil);
    fmTests.Caption := dlgOpen.FileName;
    stop := false;
    LirePasAPas(Img, 10);
	End;
end;

procedure TfmTests.btnQuantClick(Sender: TObject);
Var i, j: Integer;
begin
  For i := 0 to 7 do for j := 0 to 7 do
    StringGrid4.Cells[i, j] := IntToStr(Round(StrToInt(StringGrid2.Cells[i, j]) / StrToInt(StringGrid3.Cells[i, j])));
end;

procedure TfmTests.btnQuAutoClick(Sender: TObject);
Var qualite, i, j: Integer;
begin
	qualite := StrToInt(Edit10.Text);
  For i := 0 to 7 do for j := 0 to 7 do
  	StringGrid3.Cells[i, j] := InttoStr(1 + Qualite * ( 1 + i + j));
end;

procedure TfmTests.btnDequantClick(Sender: TObject);
Var i, j: Integer;
begin
  For i := 0 to 7 do for j := 0 to 7 do
    StringGrid5.Cells[i, j] := IntToStr(StrToInt(StringGrid4.Cells[i, j]) * StrToInt(StringGrid3.Cells[i, j]));
end;

procedure TfmTests.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  stop := true;
end;

procedure TfmTests.btnTransfoLCClick(Sender: TObject);
Var
	CoulLC: sYCbCr;
  Coul: TColor;
begin
	CoulLC := sYCbCr.Create;
	CoulLC.FromRGB(RGB(StrToInt(Edit3.Text), StrToInt(Edit4.Text), StrToInt(Edit5.Text)));
	Edit6.Text := IntToStr(CoulLC.Y);
	Edit7.Text := IntToStr(CoulLC.Cb);
	Edit8.Text := IntToStr(CoulLC.Cr);
	Coul := CoulLC.ToRGB;
	Edit1.Text := IntToStr(GetRValue(Coul));
	Edit2.Text := IntToStr(GetGValue(Coul));
	Edit9.Text := IntToStr(GetBValue(Coul));
end;

procedure TfmTests.btnChargerLCClick(Sender: TObject);
begin
	If ColorDialog1.Execute then
  Begin
		Edit3.Text := IntToStr(GetRValue(ColorDialog1.Color));
		Edit4.Text := IntToStr(GetGValue(ColorDialog1.Color));
		Edit5.Text := IntToStr(GetBValue(ColorDialog1.Color));
  ENd;
end;


procedure TfmTests.Button1Click(Sender: TObject);
begin
	If dlgOpen2.Execute Then
	Begin
  	fmProgress.Show; fmAccueil.Enabled := False;
  	If UpperCase(ExtractFileExt(dlgOpen2.FileName)) = '.BMP' Then ChargerAllBMP(dlgOpen2.FileName, Img, Pss, Nil) Else
		If UpperCase(ExtractFileExt(dlgOpen2.FileName)) = '.JTPE' Then	ChargerJTPE(dlgOpen2.FileName, Img, Pss, Nil) Else
		If UpperCase(ExtractFileExt(dlgOpen2.FileName)) = '.PTPE' Then ChargerPTPE(dlgOpen2.FileName, Img, Pss, Nil);
    fmProgress.Close; fmAccueil.Enabled := True;

		If dlgOpen2.Execute Then
		Begin
	  	fmProgress.Show; fmAccueil.Enabled := False;
	  	If UpperCase(ExtractFileExt(dlgOpen2.FileName)) = '.BMP' Then ChargerAllBMP(dlgOpen2.FileName, Img2, Pss, Nil) Else
			If UpperCase(ExtractFileExt(dlgOpen2.FileName)) = '.JTPE' Then	ChargerJTPE(dlgOpen2.FileName, Img2, Pss, Nil) Else
			If UpperCase(ExtractFileExt(dlgOpen2.FileName)) = '.PTPE' Then ChargerPTPE(dlgOpen2.FileName, Img2, Pss, Nil);
	    fmProgress.Close; fmAccueil.Enabled := True;

      ShowMessage('EQM = ' + IntToStr(EQM(Img, Img2)));
      Img2.Largeur := 0; Img2.Hauteur := 0; SetLength(Img2.Pix, 0, 0);
		End;
	End;
end;

end.
