unit JpegOptions;
// options du JPEG  l'enregistrement (qualit)

(*
 TPE 2001-2002
 DODANE Jean-Baptiste, ROUSSILLON Cyril  TS3
 Lyce Xavier Marmier, PONTARLIER

 Pour toute question, vous pouvez nous contacter :
   Jean-Baptiste (LZW, RLE) : jb@jbdsoftware.fr.st
   Cyril (JPEG, prdictif)  : cyril@crtek.fr.st
   
 Les TPE complets sont disponibles  l'adresse :
   www.chez.com/itek
 Ou sur nos sites personnels :
   www.jbdsoftware.fr.st
   www.crteknologies.fr.st
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TfmJpegOptions = class(TForm)
    Button1: TButton;
    Button2: TButton;
    rgQualite: TRadioGroup;
    edQualite: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure edQualiteExit(Sender: TObject);
    procedure rgQualiteClick(Sender: TObject);
  private
    { Dclarations prives}
  public
    { Dclarations publiques}
  end;

var
  fmJpegOptions: TfmJpegOptions;

implementation

{$R *.DFM}

procedure TfmJpegOptions.Button1Click(Sender: TObject);
begin
	ModalResult := mrOk;
end;

procedure TfmJpegOptions.Button2Click(Sender: TObject);
begin
	ModalResult := mrCancel;
end;

procedure TfmJpegOptions.edQualiteExit(Sender: TObject);
begin
	If StrToInt(edQualite.Text) < 1 Then edQualite.Text := '1' Else
  If StrToInt(edQualite.Text) > 100 Then edQualite.Text := '100';
end;

procedure TfmJpegOptions.rgQualiteClick(Sender: TObject);
begin
	If rgQualite.ItemIndex = 1 Then edQualite.Enabled := False Else edQualite.Enabled := True;
end;

end.
